﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.ChartView;

namespace wpf_ChartView_630505
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = this.GetData();
        }


        private object GetData()
        {
            return new List<PlotInfo>() 
			{
				new PlotInfo { Date = new DateTime(2012, 11, 16), Price = 33,},
				new PlotInfo { Date = new DateTime(2012, 12, 17), Price = 23,},
				new PlotInfo { Date = new DateTime(2013, 1, 18), Price = 47,},
				//new PlotInfo { Date = new DateTime(2013, 2, 19), Price = null,},
				new PlotInfo { Date = new DateTime(2013, 3, 20), Price = 49,},
				new PlotInfo { Date = new DateTime(2013, 6, 23), Price = 38,},
			};
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            LineSeries lineSeries = this.PriceChart.Series[0] as LineSeries;
            if ((lineSeries != null) && (lineSeries.ItemsSource != null))
            {
                BollingerBandsIndicator indicator = new BollingerBandsIndicator();
                indicator.Period = 5;
                indicator.StandardDeviations = 2;
                indicator.CategoryBinding = lineSeries.CategoryBinding;
                indicator.ValueBinding = lineSeries.ValueBinding;
                indicator.ItemsSource = lineSeries.ItemsSource;

                indicator.Stroke = Brushes.Red;
                indicator.LowerBandStroke = Brushes.Red;
                indicator.StrokeThickness = 5;
                indicator.LowerBandStroke = Brushes.Beige;

                this.PriceChart.Indicators.Add(indicator);

                // work-around
                indicator.LayoutUpdated += this.indicator_LayoutUpdated;
            }
        }

        void indicator_LayoutUpdated(object sender, EventArgs e)
        {
            var indicator = Telerik.Windows.Controls.ChildrenOfTypeExtensions.ChildrenOfType<BollingerBandsIndicator>(this.PriceChart).FirstOrDefault();
            if (indicator == null)
                return;
            
            var paths = Telerik.Windows.Controls.ChildrenOfTypeExtensions.ChildrenOfType<Path>(indicator).ToList();
            if (paths.Count == 0)
                return;

            indicator.LayoutUpdated -= this.indicator_LayoutUpdated;
            paths[1].StrokeThickness = paths[0].StrokeThickness;
        }
    }

    public class PlotInfo
    {
        public DateTime? Date { get; set; }
        public double? Price { get; set; }
    }

}
